<?php

class adminvyrobceController extends baseadminController {

  function __construct() {
    $this->controller_name = 'Výrobci';
    $this->controller_fname = 'adminvyrobce';
    $this->controller_info = 'Modul umožňuje udržovat informace o výrobcích zboží. U každého produktu je pak možné zobrazit informace o výrobci.';
    $this->entita_classname = 'Vyrobce';
    parent::__construct();
  }

  public function seznam($args) {

    $table_id = 'seznamVyrobci';
		$entita = new $this->entita_classname();

    $this->registry->jscript->addJqFunction('"#'.$table_id.'"', 'tablesorter','','','','','','document_ready');

    $query = $entita->getAllQuery();
    $filtr_query = array();
    $this->setFilter($filtr_query, $entita);
    $this->myOrder($filtr_query, $entita);
    $strankovani = $this->addLimit($query, $filtr_query ,$entita);
		$query = array_merge($query,$filtr_query);

    $result = dibi::query($query);
    $zaznamy = $result->fetchAll();
    unset($result);
   
    foreach($zaznamy as $key=>$item ) {
      $zaznamy[$key]['URL'] = '<a href="'.$item['URL'].'" target="_blank">'.$item['URL'].'</a>';
      if (empty($item['LOGO'])) {
        $zaznamy[$key]['LOGO'] = 'není';
      }
      else {
        if (file_exists(PATH_VYROBCE.$item['LOGO'])) {
          $zaznamy[$key]['LOGO'] = 'V pořádku';
        }
        else {
          $zaznamy[$key]['LOGO'] = 'Chyba!';
        }
        
      }
      
    }

    array_walk($zaznamy,
      'Tools::addLink',
      array('UPRAVIT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'upravit'),
          'addindex' => 'ID',
          'text'	 => ICO_UPRAVIT
        ),
        'SMAZAT' => array(
          'link' => Tools::controllerlink($this->controller_fname, 'smazat'),
          'addindex' => 'ID',
          'text'	 => ICO_SMAZAT
        )
      )
    );

    $hlavicka = array(
      'ID' 		=> 'Id',
      'NAZEV' => 'Název',
      'URL'  	=> 'Url',
      'LOGO' 	=> 'Logo',
      'S_NAZEV' => 'Stav',
      'UPRAVIT' => '',
    	'SMAZAT' => '',
    );
  
    $obsah_css = array(
      'ID' 			=> 'a_c',
      'S_NAZEV' => 'a_c',
      'LOGO'		=> 'a_c',
      'UPRAVIT' => 'a_c',
    	'SMAZAT' => 'a_c',
    );

    $hlavicka_css = array(
      'UPRAVIT' => 'nosort',
    	'SMAZAT'  => 'nosort',
    );
    $this->thCss($hlavicka_css);

    $this->html = $this->getTable($table_id, $hlavicka, $zaznamy,
      array('class' => 'seznam tablesorter', 'summary' => $this->controller_name ),
      $obsah_css, array('ID', 'SMAZAT'), $hlavicka_css, 'multisort', $entita->filtry, false
    );
		$this->html .= '<div class="strankovani">'.$strankovani.'</div></form>';
    $this->setView();

  }

  public function pridat($args) {
    
    $form_id = 'PridatVyrobceForm';
    $entita = new $this->entita_classname();

    if ($this->registry->form_send) {
      if (Validate::entita($entita,true) !== false) {

        $entita->setFromPost();
        $entita->insert();
        Tools::setMessage('Záznam '.$entita->nazev.' byl přidán', CSS_MESS, 1);

      	if ((!empty($_FILES['new_logo']['name']))) {
          try {
            $logo = Tools::moveUploadedImage('new_logo', PATH_VYROBCE, $entita->id);
            $entita->updateLogo($logo);
          }
          catch (Appliexception $e) {
          	$e->checkLevel();
            $_POST['uloz'] = true;     
            $this->getMessage();     
          }
        }

        if (isset($_POST['uloz_seznam'])) {
        	$redirect = Tools::ControllerLink($this->controller_fname,'seznam' );      
        }
        elseif (isset($_POST['uloz_dalsi'])) {
          $redirect = Tools::ControllerLink($this->controller_fname,'pridat');
        }
        elseif (isset($_POST['uloz_pokracuj'])) {
          $redirect = Tools::ControllerLink('adminadresa','pridat', array ('vyrobce', $entita->id) );
          Tools::setMessage('Výrobce '.$entita->nazev.' byl přidán.
          	<br /> Nyní můžete zadat adresu výrobce.', CSS_MESS, 1);
        }
        else {
        	$redirect = Tools::ControllerLink($this->controller_fname,'upravit', array( $entita->id) ); 
        }
        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje '.$valid_err, 'err_mess', CSS_ERR);
      }
    }

    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->openFieldset('Přidat výrobce');
    $form->addLabel('Jméno', 'nazev', array());
    $form->addInput('text', 'nazev', MY,array(), $entita->validate['nazev'],true);
    $form->addLabel('Popis', 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'));
    $form->addTag('br');
    $form->addLabel('Url', 'url', array(), 'např. www.philips.cz');
    $form->addInput('text', 'url', MY,array('class' => 'vetsi'), $entita->validate['url'],true);
    $form->addLabel('Logo', 'new_logo', array());
    $form->addInput('file', 'new_logo', MY,array(), $entita->validate['logo'],true);

    $form->addTag('br');
    $form->addLabel('Stav', 'stav' );
    $form->stateSelect($entita, true);

    $form->openTag('div', array('class' => 'bb_l'));
    $form->addTag('hr',array('class' => 'fcleaner '));
    $form->addInput('submit', 'uloz_dalsi', 'Uložit a vložit další');
    $form->addInput('submit', 'uloz_seznam', 'Uložit a zobrazit seznam');
//		$form->addInput('submit', 'uloz_pokracuj', 'Uložit a vložit adresu');
		$form->addInput('submit', 'uloz', 'Uložit a zobrazit');
    $form->closeTag();
    $form->closeFieldset();
    $form->closeForm();
    
    $this->html = $form->get();
    $this->setView('content.tpl');

  }
  
  public function upravit($args) {

    $id = @$args[0];
    $form_id = 'UpravitVyrobceForm';
		$entita = new $this->entita_classname();

    if ($this->registry->form_send) {
      if (Validate::entita($entita) !== false) {
        
        if (!empty($_FILES['new_logo']['name'])) {
          try {
            $_POST['logo'] = Tools::moveUploadedImage('new_logo', PATH_VYROBCE, $id, true);
          }
          catch (Appliexception $e) {

            $e->checkLevel(2);
            $_POST['uloz'] = true;          

          }
        }
        elseif (isset($_POST['del_logo'])) {
        	try {
        		$logo = dibi::query('SELECT LOGO FROM [VYROBCE] WHERE ID = %i',$id)->fetchSingle();
        		Tools::deleteFile($logo, PATH_VYROBCE);
        		$_POST['logo'] = 0;
        	}
          catch (Appliexception $e) {

            $e->checkLevel(2);
            $_POST['uloz'] = true;          

          }
        }

				
        if (isset($_POST['uloz'])) {
          $redirect = Tools::ControllerLink($this->controller_fname,'upravit', array( $id) );          
        }
        else {
        	$redirect = Tools::ControllerLink($this->controller_fname,'seznam' );          
        }

        $entita->setFromPost();
        $entita->upravit($id,$form_id);
        Tools::setMessage('Záznam '.$entita->nazev.' byl upraven', '', 1);
        Tools::redirect($redirect);
        die;

      }
      else {
        $valid_err = Validate::error();
        Tools::setMessage('Špatně vyplněné údaje'.$valid_err, CSS_ERR);
      }
    }

    $form_value = $entita->loadByID($id, true, $this->registry->postRestore);

    $form = new Form($form_id, '', 'post', array('class' => 'myForm'));
    $form->setEntitaRef($entita);
    $form->setValue($form_value);
    $form->openFieldset('Upravit výrobce');
    $form->addLabel(MY, 'nazev', array());
    $form->addInput('text', 'nazev', MY,array(), MY,true);
    $form->addLabel(MY, 'popis' );
    $form->addTextarea('popis', MY, true, array('class' => 'stredni'));
    $form->addTag('br');
    $form->addLabel(MY, 'url', array(), 'např. www.philips.cz');
    $form->addInput('text', 'url', MY,array('class' => 'vetsi'),MY,true);
    $form->addInput('hidden', 'logo', MY);
    $form->addLabel(MY, 'logo', array());
    if (empty($entita->logo)) {
      $form->addTag('img', array('src' => URL.PATH_VYROBCE.$entita->logo), false);
    }
    else {
      $form->addInnerHTML('<span>neuvedeno</span>');
    }
    $form->addTag('br');
    $form->addTag('br');
    $form->addLabel('Smazat logo', 'del_logo');
    $form->addInput('checkbox','del_logo','');
		$form->addTag('br');
		$form->addTag('br');

    $form->addLabel('Nové logo', 'new_logo', array(), 'Pokud chcete změnit logo výrobce, vyberte soubor. Pokud již logo existuje, bude nahrazeno.');
    $form->addInput('file', 'new_logo', MY,array(), $entita->validate['logo'], true);

    $form->addTag('br');
    $form->addLabel(MY, 'stav' );

    if ($form->stateSelect($entita) == true) {
      $form->addInput('hidden', HASH, MY);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz', 'Uložit');
      $form->addInput('submit', 'uloz_seznam', 'Uložit a zobrazit seznam');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }
    else {
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addInnerHTML('Nemáte oprávnění pro modifikaci záznamu v uvedeném stavu.<br /><br />');
      $form->addInput('reset', 'reset', 'Vrátit změny');
      $form->closeTag();
    }
    $form->closeFieldset();
    $this->html = $form->get();

    $this->setView('content.tpl');
  }

  public function smazat($args) {

		$form_id = 'smazatVlastnost';
		$id = @$args[0];
		$entita = new $this->entita_classname();
		
		if ($this->registry->form_send) {
			$my_id = @$this->registry->$form_id;

			if ( $my_id == $id) {
				$entita->delete($id);
				Tools::setMessage('Záznam byl smazán', '', 1);
				Tools::redirect(Tools::controllerlink($this->controller_fname, 'seznam'));
			}
			else {
      	Tools::setMessage('Neoprávněný pokus o smazání položky!');
      	return $this->seznam(array());
      	die;
			}
		}
		
		$result = dibi::query('SELECT V.*,
  		(SELECT COUNT(*) FROM PRODUKT P
  			WHERE P.ID_VYR = V.ID) AS PRODUKTY
			FROM VYROBCE V
			WHERE V.ID = %i',$id);
		
		if (count($result) == 0) {
      Tools::setMessage('Požadovaný záznam neexistuje!');
      return $this->seznam(array());
    }

		$this->registry->addPersistent($form_id,$id, 2);
		$r = $result->fetchAll();
		$zaznam = $r[0];

    if ( $zaznam['PRODUKTY'] > 0 ) {
			$result = dibi::query('SELECT P.ID, P.NAZEV
				FROM [PRODUKT] P
  			WHERE P.ID_VYR = %i', $id);
			$r = $result->fetchAssoc('ID');
			
			$produkty = '<div class="warning"><h3>Výrobce je uveden u následujících produktů</h3>';
			$produkty .= '<p><ul class="smazat">'; 
			foreach($r as $row) {
				$produkty .= '<li> #id: '.$row['ID'].' - '.$row['NAZEV'].'</li>';
			}
			$produkty .= '</ul>Chcete-li výrobce odstranit, odeberte ji nejprve z uvedených produktů.</p>
			</div>';
		}

  	$form = new Form($form_id);
		$form->openFieldset('Smazat záznam');
		if ( $zaznam['PRODUKTY'] > 0 ) {
  		$form->openTag('h3');
  		$form->addInnerHTML('Výrobce <b>'.$zaznam['NAZEV'].'</b> nelze smazat!');
  		$form->closeTag();
  		$form->addInnerHTML($produkty);
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}
		else {
			$this->registry->addPersistent($form_id,$id, 2);
  		$form->openTag('h2');
  		$form->addInnerHTML('Chcete opravdu odstranit výrobce <b>'.$zaznam['NAZEV'].'</b> (id: '.$zaznam['ID'].') ?');
  		$form->closeTag();
      $form->openTag('div', array('class' => 'bb_l'));
      $form->addTag('hr',array('class' => 'fcleaner '));
      $form->addInput('submit', 'uloz', 'Smazat');
      $form->openTag('a', array('href' => Tools::controllerlink($this->controller_fname,'seznam')));
      $form->addInput('button', 'reset', 'Zrušit');
      $form->closeTag();
      $form->closeTag();
		}
    
    $this->html = $form->get();
    $this->setView('content.tpl');
		
	}
  
}
?>